Option Explicit

Private Const FileName As String = "C:\sample.mdb"
Private Const SampleDataCount As Long = 100000 '10

Public Sub Main()
    '--- O:Tvf[^x[X̍쐬 ---
    Dim DE As DAO.DBEngine
    Set DE = New DAO.DBEngine
    Dim WS As DAO.Workspace
    Set WS = DE.CreateWorkspace("#Default Workspace#", "Admin", "")
    Dim DB As DAO.Database
    Set DB = WS.CreateDatabase(FileName, dbLangJapanese)
    WS.BeginTrans
    DB.Execute "CREATE TABLE TEST (ID LONG, NAME TEXT(50))"
    DE.Idle dbRefreshCache

    '--- v:ݏJn ---
    Dim StartTime As Single
    StartTime = Timer

    'e[u^CṽR[hZbgJ
    Dim RS As DAO.Recordset
    Set RS = DB.OpenRecordset("TEST", dbOpenTable, _
            dbDenyWrite Or dbInconsistent, dbPessimistic)

    'FieldϐLbV
    Dim fID As DAO.Field, fName As DAO.Field
    Set fID = RS.Fields("ID")
    Set fName = RS.Fields("NAME")

    '_~[f[^쐬
    Randomize
    Dim I As Long
    For I = 1 To SampleDataCount
        RS.AddNew
        fID.Value = I
        fName.Value = GetRandomText()
        RS.Update
    Next

    Set fID = Nothing
    Set fName = Nothing
    RS.Close
    Set RS = Nothing
    WS.CommitTrans dbForceOSFlush


    '--- v ---
    Dim EndTime As Single
    EndTime = Timer

    MsgBox FormatNumber(EndTime - StartTime, 4) & "b"

    DB.Close
    Set DB = Nothing
    WS.Close
    Set WS = Nothing
End Sub

Private Function GetRandomText() As String
  Dim count As Long
  count = CLng(Int(50 * Rnd()))
  GetRandomText = String(count, "@")
End Function
